package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmDomesticMarketEntityIndustryInfo;
import com.zksy.system.basicData.service.CrmDomesticMarketEntityIndustryInfoService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 内资市场主体行业信息Controller
 *
 * @author sy
 * @date 2024-06-05
 */
@RestController
@RequestMapping("/crmDomesticMarketEntityIndustryInfo")
@Api(tags = "内资市场主体行业信息", description = "内资市场主体行业信息desc")
public class CrmDomesticMarketEntityIndustryInfoController extends BaseController{

    @Autowired
    private CrmDomesticMarketEntityIndustryInfoService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "内资市场主体行业信息搜索getById")
    public CrmDomesticMarketEntityIndustryInfo getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "内资市场主体行业信息分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "内资市场主体行业信息查询所有")
    public List<CrmDomesticMarketEntityIndustryInfo> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增内资市场主体行业信息
     */
    @PostMapping("/save")
    @ApiOperation(value = "内资市场主体行业信息新增")
    @Log(title = "新增内资市场主体行业信息", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmDomesticMarketEntityIndustryInfo crmDomesticMarketEntityIndustryInfo) {
        return service.save(crmDomesticMarketEntityIndustryInfo);
    }

    /**
     * 修改内资市场主体行业信息
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "内资市场主体行业信息修改")
    @Log(title = "修改内资市场主体行业信息", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmDomesticMarketEntityIndustryInfo crmDomesticMarketEntityIndustryInfo) {
        return service.updateById(crmDomesticMarketEntityIndustryInfo);
    }

    /**
     * 导入内资市场主体行业信息
     */
    @ApiOperation("内资市场主体行业信息导入")
    @Log(title = "内资市场主体行业信息", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmDomesticMarketEntityIndustryInfo> crmDomesticMarketEntityIndustryInfoAll = service.list();
            List<CrmDomesticMarketEntityIndustryInfo> list = ExcelUtils.readMultipartFile(file, CrmDomesticMarketEntityIndustryInfo.class,CrmDomesticMarketEntityIndustryInfo.class.getDeclaredFields().length - 2);
            if(crmDomesticMarketEntityIndustryInfoAll != null && crmDomesticMarketEntityIndustryInfoAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("内资市场主体行业信息导出")
    @Log(title = "内资市场主体行业信息", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmDomesticMarketEntityIndustryInfo> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"内资市场主体行业信息",wrapperList,CrmDomesticMarketEntityIndustryInfo.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "内资市场主体行业信息", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除内资市场主体行业信息", notes = "删除内资市场主体行业信息")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"内资市场主体行业信息模板");
    }
}

